//Ces dclarations ne sont que le corps des feuilles ci-dessous
#declare BODY=
height_field
{
	tga "LEAF.tga"
	water_level .01
	smooth
	translate <0,0,-0.5>
}
#declare BODY_tex=
object
{
	BODY
	pigment
	{
		image_map
		{
			gif "LEAF.gif"
			interpolate 2
		}
		rotate <90,0,0>
		translate <0,0,-.5>
	}
}
#declare BODY_cut=
height_field
{
	tga "LEAFx.tga"
	smooth
	water_level .001
	scale <1,1.1,1>
	translate <0,0,-.5>
}
#declare BLOS_BODY=
height_field
{
	tga "BLOSSOM.tga"
	water_level .05
	smooth
	translate <-.5,0,-0.5>
}


//XXXXXXXXXXX F E U I L L E S XXXXXXXXXXXXXXXXXXX
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//Feuilles simples
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//LEAF - une feuilles pour un aperu correct et rapide ; pour des feuilles de forme simple; 
//ce n'est qu'une sphre.
#declare LEAF=
sphere
{
	<.5,0,0>,.5
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//CSG_LEAF - Pour des petites feuilles de forme assez simple; avec un dessous concave; 
//ncessite plus de mmoire que LEAF
#declare CSG_LEAF=
sphere
{
	<.5,0,0>,.5
	clipped_by
	{
		cylinder
		{
			<.5,0,0>,<.5,1.1,0>,.5
			scale <1,1,2/3>
		}
	}
	scale <1,1,3/2>
}

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//Meilleures feuilles, en height field
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//HF_LEAF - Avec des contours naturels, bien pour beaucoup de types de feuilles
#declare HF_LEAF=
object
{
	BODY
	clipped_by
	{
		object
		{
			BODY_cut
			scale <.999,1,.99>
		}
	}
}

//HF_LEAF_tex - cette feuille a la mme forme que LEAF, mais avec une texture raliste;
//Le dsavantage de a est que toutes les feuilles de l'arbre sont texturises/colores.
#declare HF_LEAF_tex=
object
{
	BODY_tex
	clipped_by
	{
		object
		{
			BODY_cut
			scale <.999,1,.99>
		}
	}
}

//HF_PALMLEAF - pour des feuilles longues et minces, c'est prfrable d'utiliser PALMLEAVES 
//puisque la taille de la structure est mieux gre.
#declare HF_PALMLEAF=
object
{
	BODY
	clipped_by
	{
		object
		{
			BODY_cut
			scale <.999,1,.5>
		}
	}
	scale <1,1,2>
}

//HF_PALMLEAF_tex - cette feuillea la mme forme que PALMLEAF, but with a realistic texture;
//l'inconvniant est que toutes les feuilles de l'arbre ont la mme texture/couleur
#declare HF_PALMLEAF_tex=
object
{
	BODY_tex
	clipped_by
	{
		object
		{
			BODY_cut
			scale <.999,1,.4>
		}
	}
	scale <1,1,2.5>
}

//HF_PALMLEAF1 - cette feuille est la mme que PALMLEAF, mais avec un bout arrondi
#declare HF_PALMLEAF1=
object
{
	BODY
	translate <-.5,0,0>
	scale <1,1,1>
	clipped_by
	{
		cylinder
		{
			<0,-2,0>,<0,2,0>,.5
			scale <.99,1,.4>
		}
	}
	scale <1,1,2.5>
	translate <.5,0,0>
}

//HF_PALMLEAF1_tex - et voici sa texture
#declare HF_PALMLEAF1_tex=
object
{
	BODY_tex
	translate <-.5,0,0>
	scale <1,1,1>
	clipped_by
	{
		cylinder
		{
			<0,-2,0>,<0,2,0>,.5
			scale <.99,1,.4>
		}
	}
	scale <1,1,2.5>
	translate <.5,0,0>
}

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//Quelques bouquets
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//BLOSSOM1 - avec 6 petites feuilles rondes
#declare BLOSSOM1=
object
{
	BLOS_BODY
	scale <1,.5,1>
	clipped_by
	{
		torus
		{
			.275,.24
			scale <1.0,1.6,1.0>
			inverse
		}
	}
	scale <1,2,1>
	rotate <0,0,-90>
	translate <-.05,0,0>
	finish{ambient .2}
}

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//BLOSSOM2 - avec 6 petites feuilles fines
#declare BLOSSOM2=
object
{
	BLOS_BODY
	scale <1,.5,1>
	clipped_by
	{
		torus
		{
			.275,.23
			scale <1.0,1.85,1.0>
			inverse
		}
	}
	scale <1,2,1>
	rotate <0,0,-90>
	translate <-.05,0,0>
	finish{ambient .2}
}





